;;File Version: 2.2
;;Last Modified: November 17, 2004
;;By: Josh Colwell

PRO GEOM_PIXEL_WIDGET, pixelvector, toplevelbase, OUTPUTPIXEL = OUTPUTPIXEL
;;Child widget of GEOMETER_WIDGET that allows the user to select among the 64
;;spatial pixels in a UVIS spectrographic channel. Data for the selected pixels
;;are calculated by GEOMETER.
;;January 12, 2004
;;Joshua Colwell, LASP, University of Colorado.
;;January 15, 2004: add outputpixel keyword.
;;February 14, 2004: added Cancel and Apply buttons.
;;July 15, 2004: Fix display of selected rows to fit on screen and not be
;;just in one column.
;;September 17, 2004: Modified to use new topleveluval as pointer.
;;November 5, 2004: Include row of pixels accidentally omitted before.
;;November 17,2004: Update appearance of buttons to show user which ones
;;are set. User must still use the Done or Apply button for selections to
;;take effect.

IF KEYWORD_SET(outputpixel) THEN output = 1B ELSE output = 0B

pxbase = WIDGET_BASE(TITLE='Select Spectrograph Rows', $
    GROUP_LEADER = toplevelbase, /COLUMN)

rows07base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval = {id:'Boresight', type:'Button', index:64}
button64 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 0'
buval.index = 0
button0 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 1'
buval.index = 1
button1 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 2'
buval.index = 2
button2 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 3'
buval.index = 3
button3 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 4'
buval.index = 4
button4 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 5'
buval.index = 5
button5 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 6'
buval.index = 6
button6 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 7'
buval.index = 7
button7 = WIDGET_BUTTON(rows07base, VALUE = buval.id, UVALUE = buval)

rows815base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 8'
buval.index = 8
button8 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 9'
buval.index = 9
button9 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 10'
buval.index = 10
button10 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 11'
buval.index = 11
button11 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 12'
buval.index = 12
button12 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 13'
buval.index = 13
button13 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 14'
buval.index = 14
button14 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 15'
buval.index = 15
button15 = WIDGET_BUTTON(rows815base, VALUE = buval.id, UVALUE = buval)

rows1623base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 16'
buval.index = 16
button16 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 17'
buval.index = 17
button17 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 18'
buval.index = 18
button18 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 19'
buval.index = 19
button19 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 20'
buval.index = 20
button20 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 21'
buval.index = 21
button21 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 22'
buval.index = 22
button22 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 23'
buval.index = 23
button23 = WIDGET_BUTTON(rows1623base, VALUE = buval.id, UVALUE = buval)

rows2431base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 24'
buval.index = 24
button24 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 25'
buval.index = 25
button25 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 26'
buval.index = 26
button26 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 27'
buval.index = 27
button27 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 28'
buval.index = 28
button28 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 29'
buval.index = 29
button29 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 30'
buval.index = 30
button30 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 31'
buval.index = 31
button31 = WIDGET_BUTTON(rows2431base, VALUE = buval.id, UVALUE = buval)

rows3239base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 32'
buval.index = 32
button32 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 33'
buval.index = 33
button33 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 34'
buval.index = 34
button34 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 35'
buval.index = 35
button35 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 36'
buval.index = 36
button36 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 37'
buval.index = 37
button37 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 38'
buval.index = 38
button38 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 39'
buval.index = 39
button39 = WIDGET_BUTTON(rows3239base, VALUE = buval.id, UVALUE = buval)

rows4047base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 40'
buval.index = 40
button40 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 41'
buval.index = 41
button41 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 42'
buval.index = 42
button42 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 43'
buval.index = 43
button43 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 44'
buval.index = 44
button44 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 45'
buval.index = 45
button45 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 46'
buval.index = 46
button46 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 47'
buval.index = 47
button47 = WIDGET_BUTTON(rows4047base, VALUE = buval.id, UVALUE = buval)

rows4855base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 48'
buval.index = 48
button48 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 49'
buval.index = 49
button49 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 50'
buval.index = 50
button50 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 51'
buval.index = 51
button51 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 52'
buval.index = 52
button52 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 53'
buval.index = 53
button53 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 54'
buval.index = 54
button54 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 55'
buval.index = 55
button55 = WIDGET_BUTTON(rows4855base, VALUE = buval.id, UVALUE = buval)

rows5663base = WIDGET_BASE(pxbase, /ROW, /NONEXCLUSIVE)
buval.id = 'Row 56'
buval.index = 56
button56 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 57'
buval.index = 57
button57 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 58'
buval.index = 58
button58 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 59'
buval.index = 59
button59 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 60'
buval.index = 60
button60 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 61'
buval.index = 61
button61 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 62'
buval.index = 62
button62 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)
buval.id = 'Row 63'
buval.index = 63
button63 = WIDGET_BUTTON(rows5663base, VALUE = buval.id, UVALUE = buval)


buttonrow = WIDGET_BASE(pxbase, /ROW)
buval.id = 'Done'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
buval.id = 'Cancel'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
buval.id = 'Apply'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
IF NOT output THEN BEGIN
buval.id = 'Select All'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
buval.id = 'Select Odd'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
buval.id = 'Select Even'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
ENDIF
buval.id = 'Clear All'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
buval.id = 'Display Selected Rows'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)
buval.id = 'Help'
button = WIDGET_BUTTON(buttonrow, VALUE = buval.id, UVALUE = buval)

WIDGET_CONTROL, pxbase, /REALIZE
mainuval = {vec:pixelvector, toplevelbase:toplevelbase, output:output, $
            buttonids:[button0, button1, button2, button3, button4, $
           button5, button6, button7, button8, button9, button10, $
           button11, button12, button13, button14, $
           button15, button16, button17, button18, $
           button19, button20, button21, button22, $
           button23, button24, button25, button26, $
           button27, button28, button29, button30, $
           button31, button32, button33, button34, $
           button35, button36, button37, button38, $
           button39, button40, button41, button42, $
           button43, button44, button45, button46, $
           button47, button48, button49, button50, $
           button51, button52, button53, button54, $
           button55, button56, button57, button58, $
           button59, button60, button61, button62, button63, button64]}
WIDGET_CONTROL, pxbase, SET_UVALUE = mainuval
FOR i=0,64 DO BEGIN
    CASE mainuval.vec[i] OF
        0: WIDGET_CONTROL, mainuval.buttonids[i], SET_BUTTON = 0
        ELSE: WIDGET_CONTROL, mainuval.buttonids[i], /SET_BUTTON
    ENDCASE
ENDFOR

XMANAGER, "GEOM_PIXEL", pxbase, EVENT_HANDLER = 'GEOM_PIXEL_EVENT'

END




PRO GEOM_PIXEL_EVENT, event

WIDGET_CONTROL, event.id, GET_UVALUE = uval
WIDGET_CONTROL, event.top, GET_UVALUE = mainuval
WIDGET_CONTROL, mainuval.toplevelbase, GET_UVALUE = toplevelptr

CASE uval.id OF
    'Select All': mainuval.vec[*] = 1B
    'Clear All': mainuval.vec[*] = 0B
    'Display Selected Rows': BEGIN
       selected = WHERE((*toplevelptr).pxvec)
       nselected = N_ELEMENTS(selected)
       nrowstodisplay = FIX(nselected/8)
       buffer = ["Currently selected rows: "]
       FOR buffer_row = 0, nrowstodisplay-1 DO BEGIN
        row_text = ' '
        FOR row_number = 0,7 DO BEGIN
         IF buffer_row*8+row_number LT nselected THEN $
             row_text = row_text+STRING(selected[buffer_row*8+row_number])
        ENDFOR
        buffer = [buffer, row_text]
       ENDFOR
       IF 8*nrowstodisplay LT nselected THEN BEGIN
        nmissing = nselected-8*nrowstodisplay
        row_text = ' '
        FOR row_number = 0, nmissing-1 DO BEGIN
            row_text = row_text+STRING(selected[8*nrowstodisplay+row_number])
        ENDFOR
        buffer = [buffer, row_text]
       ENDIF
       junk = DIALOG_MESSAGE(buffer, /INFORMATION)
    END
    'Done': BEGIN
        IF mainuval.output THEN BEGIN
           outputpx = WHERE(mainuval.vec)
           IF N_ELEMENTS(outputpx) GT 1 THEN BEGIN
             junk = DIALOG_MESSAGE("Must select only one row.", $
              /INFORMATION)
             RETURN
           ENDIF
           IF NOT (*toplevelptr).pxvec[outputpx[0]] THEN BEGIN
       selected = WHERE((*toplevelptr).pxvec)
       nselected = N_ELEMENTS(selected)
       nrowstodisplay = FIX(nselected/8)
       buffer = ["Your selected output row",$
              "is not one for which data have", $
              "been computed. These are the rows",$
              "for which data exist: "]
       FOR buffer_row = 0, nrowstodisplay-1 DO BEGIN
        row_text = ' '
        FOR row_number = 0,7 DO BEGIN
         IF buffer_row*8+row_number LT nselected THEN $
             row_text = row_text+STRING(selected[buffer_row*8+row_number])
        ENDFOR
        buffer = [buffer, row_text]
       ENDFOR
       IF 8*nrowstodisplay LT nselected THEN BEGIN
        nmissing = nselected-8*nrowstodisplay
        row_text = ' '
        FOR row_number = 0, nmissing-1 DO BEGIN
            row_text = row_text+STRING(selected[8*nrowstodisplay+row_number])
        ENDFOR
        buffer = [buffer, row_text]
       ENDIF
       junk = DIALOG_MESSAGE(buffer, /INFORMATION)
             RETURN
           ENDIF
         (*toplevelptr).plotpixel = outputpx[0]
          WIDGET_CONTROL, (*toplevelptr).statustext, SET_VALUE = $
            'Selected pixel '+STRING((*toplevelptr).plotpixel)+' for plotting.'
         WIDGET_CONTROL, event.top, /DESTROY
         RETURN
       ENDIF ELSE BEGIN
            (*toplevelptr).pxvec = mainuval.vec
            WIDGET_CONTROL, (*toplevelptr).statustext, SET_VALUE = $
                'Selected pixels for computation. Click Calculate to get new values.'
            WIDGET_CONTROL, event.top, /DESTROY
            RETURN
         ENDELSE
    END
    'Cancel': BEGIN
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END
    'Apply': BEGIN
        IF mainuval.output THEN BEGIN
           outputpx = WHERE(mainuval.vec)
           IF N_ELEMENTS(outputpx) GT 1 THEN BEGIN
             junk = DIALOG_MESSAGE("Must select only one row.", $
              /INFORMATION)
             RETURN
           ENDIF
           IF NOT (*toplevelptr).pxvec[outputpx[0]] THEN BEGIN
       selected = WHERE((*toplevelptr).pxvec)
       nselected = N_ELEMENTS(selected)
       nrowstodisplay = FIX(nselected/8)
       buffer = ["Your selected output row",$
              "is not one for which data have", $
              "been computed. These are the rows",$
              "for which data exist: "]
       FOR buffer_row = 0, nrowstodisplay-1 DO BEGIN
        row_text = ' '
        FOR row_number = 0,7 DO BEGIN
         IF buffer_row*8+row_number LT nselected THEN $
             row_text = row_text+STRING(selected[buffer_row*8+row_number])
        ENDFOR
        buffer = [buffer, row_text]
       ENDFOR
       IF 8*nrowstodisplay LT nselected THEN BEGIN
        nmissing = nselected-8*nrowstodisplay
        row_text = ' '
        FOR row_number = 0, nmissing-1 DO BEGIN
            row_text = row_text+STRING(selected[8*nrowstodisplay+row_number])
        ENDFOR
        buffer = [buffer, row_text]
       ENDIF
       junk = DIALOG_MESSAGE(buffer, /INFORMATION)
             RETURN
             ENDIF
         (*toplevelptr).plotpixel = outputpx[0]
          WIDGET_CONTROL, (*toplevelptr).statustext, SET_VALUE = $
            'Selected pixel '+STRING((*toplevelptr).plotpixel)+' for plotting.'
         RETURN
       ENDIF ELSE BEGIN
            (*toplevelptr).pxvec = mainuval.vec
            WIDGET_CONTROL, (*toplevelptr).statustext, SET_VALUE = $
                'Selected pixels for computation. Click Calculate to get new values.'
            RETURN
         ENDELSE
    END     ;;Apply
    'Select Odd': BEGIN
       mainuval.vec[*] = 0
       FOR i=1,63,2 DO mainuval.vec[i] = 1B
    END
    'Select Even': BEGIN
       mainuval.vec[*] = 0
       FOR i=0,62,2 DO mainuval.vec[i] = 1B
    END
    'Help': XDISPLAYFILE, 'geom_pixel_widget_help.txt'

    ELSE: mainuval.vec[uval.index] = event.select
ENDCASE

FOR i=0,64 DO BEGIN
    CASE mainuval.vec[i] OF
        0: WIDGET_CONTROL, mainuval.buttonids[i], SET_BUTTON = 0
        ELSE: WIDGET_CONTROL, mainuval.buttonids[i], /SET_BUTTON
    ENDCASE
ENDFOR

WIDGET_CONTROL, event.top, SET_UVALUE = mainuval

END
